/****
*	rview: record view for tip+
*	function:
*      View tip+ record file while tip+ is running and scripting.
*      Rview is useful to view back log if you have a window with scroll bar.
*      Please executed rview in a window tip+ is not running.
*	usage: rview
*	to quit: ^C
*	compile: cc rview.c -o rview
*	install: install -s rview /usr/local/bin
*	-Kenar-
*  1996/07: 1st ed. by Kenar
****/

#include <stdio.h>
#include <stdlib.h>
#include <sys/file.h>
#define ERR (-1)


void error(s)
char *s;
{	fprintf(stderr,"Unable to open the file: %s\n",s);
	exit(0);
}

/*
 * Don't use getc().
 * Buffered function does not work!
 * -Kenar-
 */
main(argc,argv)
int argc;
char **argv;
{	int fd;
	int n;
	char buf[BUFSIZ];
	
	/* Getting record file name from ~/.tiprecord */
	strcpy(buf,getenv("HOME"));
	strcat(buf,"/.tiprecord");
	fd = open(buf,O_RDONLY);
	if(fd == ERR) error(buf);
	n = read(fd,buf,BUFSIZ);
	buf[n] = 0;
	close(fd);
	/* then we get record file name in buf */

	/* Reading the record file until ^C from keyboard. */
	fd = open(buf,O_RDONLY);
	if(fd == ERR) error(buf);
	for(;;){
		n = read(fd,buf,BUFSIZ);
		if(n > 0) write(1,buf,n);
		else sleep(1);
	}
	/* Not reached */
}
