/*
 * Copyright (c) 1993  Kenji Arisawa. All right reserved.
 * License to freely use and distribute this software is hereby granted 
 * by the author, subject to the condition that this copyright notice 
 * remains intact.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY WARRANTIES.
 */
#ifndef lint
static char sccsid[] = "@(#)speed.c	1.0 (Kenar) 2/3/96";
#endif /* not lint */

#include <sys/ioctl.h>
#ifdef USE_TTYDEV
#include <sys/ttydev.h>
#endif

/*
 *	Baud rate mapping table
 *	- Kenar -
 */
typedef struct baudmap
{	char *name;
	int br;
	int bc;
} BAUD;
static BAUD bmap[] = 
{	/* see <sys/ttydev.h> for NeXT. - Kenar - */
	"0",	0,		B0,
	"50",	50,		B50,
	"75",	75,		B75,
	"110",	110,	B110,
	"134",	134,	B134,
	"150",	150,	B150,
	"200",	200,	B200,
	"300",	300,	B300,
	"600",	600,	B600,
	"1200",	1200,	B1200,
	"2400",	2400,	B2400,
	"4800",	4800,	B4800,
	"9600",	9600,	B9600,
#ifdef B14400
	"14400",	14400,	B14400,
#endif
#ifdef B19200
	"19200",	19200,	B19200,
#endif
#ifdef B28800
	"28800",	28800,	B28800,
#endif
#ifdef B38400
	"38400",	38400,	B38400,
#endif
#ifdef B43200
	"43200",	43200,	B43200,
#endif
#ifdef B57600
	"57600",	57600,	B57600,
#endif
#ifdef B115200
 	"115200",	115200,	B115200,
#endif
	"HUP",	0,	B0,
	"EXTA",	0,	EXTA,
	"EXTB",	0,	EXTB,
	(char*)0,	-1,		-1
};


/* baudstat: converts baud code to baud rate status */
/* old name is B_to_baud_rate */
/* unused */
char *baudstat(code)
int code;
{	/* mod by Kenar */
	int n;
	for(n=0; bmap[n].name; n++)
		if(bmap[n].bc == code)
			return(bmap[n].name);
	return("-----");
}


/* baudrate: converts baud code to baud rate */
/* unused */
int baudrate(code)
int code;
{	/* mod by Kenar */
	int n;
	for(n=0; bmap[n].name; n++)
		if(bmap[n].bc == code)
			return(bmap[n].br);
	return(-1);
}


/* baudcode: converts baud rate to baud code */
int baudcode(n)
int n;
{	/* Replaced by Kenar */
	int k;
	for(k = 0; bmap[k].br != -1; k++)
		if(bmap[k].br == n) return bmap[k].bc;
	return(0);
}

/* showbauds: shows all bauds available. */
void showbauds()
{	int k,n;
	n = 0;
	for(k = 0; bmap[k].br != -1; k++)
		if(bmap[k].br){
			printf("%7d",bmap[k].br);
			n++;
			if(n % 10 == 0) puts("");
		}
	puts("");
}
